//---------------------------------------------------------------------------

#ifndef MainH
#define MainH

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Grids.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <Buttons.hpp>

//---------------------------------------------------------------------------

#define MEM_DATA_MAX_SIZE	1000

#define MEM_DATA_AREA_ROM	0x01
#define MEM_DATA_AREA_RAM	0x02
#define MEM_DATA_AREA_IO	0x03
#define MEM_DATA_AREA_ETC	0x04

#define READ_RANGE_MAX_SIZE	16

#define VAR_MODEL_BYTE		1
#define VAR_MODEL_WORD		2
#define VAR_MODEL_DWORD		4

#define VAR_MARK_NOUSE		0	//ϐ
#define VAR_MARK_USE		1	//tϐ


struct READ_RANGE{
	struct{
		int  top;		//X^[gAhX
		int  end;		//GhAhX
		int  area;		//[(ROM,RAM,IO,ETC)
		bool permit;	//[̓Ǎ݋
	}range[READ_RANGE_MAX_SIZE];
	int size;
	int no;
};

struct MEM_DATA{
	AnsiString varName;		//ϐ
	AnsiString fileName;	//fBNgƊgq܂܂Ȃ̃t@C(ϐ̏)
	AnsiString section;		//ZNV
	int adr;				//AhX
	int size;				//TCY
	int model;				//ϐ̃TCY(1,2,4)
	int mark;				//
	int area;				//̈
};

struct MEM_DATAS{
	struct MEM_DATA mem[MEM_DATA_MAX_SIZE];
	int size;
};


//---------------------------------------------------------------------------

class TMainForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TMainMenu *MainMenu1;
	TMenuItem *File1;
	TMenuItem *L1;
	TMenuItem *Exit1;
	TStatusBar *StatusBar;
	TOpenDialog *OpenDialog1;
	TPanel *Panel1;
	TCheckBox *ConnectChk;
	TMenuItem *W1;
	TMenuItem *R1;
	TCheckBox *Check10;
	TMenuItem *OldSrcName1;
	TMenuItem *N4;
	TPopupMenu *PopupMenu1;
	TMenuItem *BYTE1;
	TMenuItem *WORD1;
	TMenuItem *DWORD1;
	TMenuItem *About1;
	TPopupMenu *PopupMenu2;
	TMenuItem *MenuItem1;
	TMenuItem *MenuItem2;
	TCheckBox *SetUpPanelChk;
	TPanel *SetUpPanel;
	TOpenDialog *WriterOpenDialog;
	TComboBox *MpuGroupBox;
	TComboBox *MpuBox;
	TStringGrid *MemRangeGrid;
	TStringGrid *RangeGrid;
	TCheckBox *RomReadChk;
	TCheckBox *RamReadChk;
	TCheckBox *IOReadChk;
	TCheckBox *EtcReadChk;
	TCheckBox *SectionViewChk;
	TCheckBox *Check2;
	TCheckBox *FileVarViewChk;
	TCheckBox *GraphPanelChk;
	TPopupMenu *PopupMenu3;
	TMenuItem *MenuItem3;
	TMenuItem *MenuItem4;
	TMenuItem *MenuItem5;
	TMenuItem *K1;
	TMenuItem *P1;
	TMenuItem *A1;
	TPanel *VarPanel;
	TStringGrid *RamView;
	TCheckBox *TerminalCheck;
	TMenuItem *N7;
	TGroupBox *GroupBox1;
	TEdit *WriterFileNameEdit;
	TButton *WriterFileNameButton;
	TEdit *WriterOptionEdit;
	TLabel *Label9;
	TLabel *Label1;
	TEdit *WriterComOptionEdit;
	TGroupBox *GroupBox2;
	TLabel *Label2;
	TLabel *Label3;
	TLabel *Label8;
	TComboBox *ComPortBox;
	TComboBox *ComSpeedBox;
	TComboBox *ComParityBox;
	TCheckBox *AutoMpuReadCheck;
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall Exit1Click(TObject *Sender);
	void __fastcall L1Click(TObject *Sender);
	void __fastcall ConnectChkClick(TObject *Sender);
	void __fastcall W1Click(TObject *Sender);
	void __fastcall R1Click(TObject *Sender);
	void __fastcall OldSrcName1Click(TObject *Sender);
	void __fastcall RamViewDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
	void __fastcall Check10Click(TObject *Sender);
	void __fastcall RamViewMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall BYTE1Click(TObject *Sender);
	void __fastcall About1Click(TObject *Sender);
	void __fastcall MenuItem1Click(TObject *Sender);
	void __fastcall SetUpPanelChkClick(TObject *Sender);
	void __fastcall WriterFileNameButtonClick(TObject *Sender);
	void __fastcall MpuGroupBoxChange(TObject *Sender);
	void __fastcall MpuBoxChange(TObject *Sender);
	void __fastcall RamViewSelectCell(TObject *Sender, int ACol, int ARow,
          bool &CanSelect);
	void __fastcall SectionViewChkClick(TObject *Sender);
	void __fastcall FileVarViewChkClick(TObject *Sender);
	void __fastcall GraphPanelChkClick(TObject *Sender);
	void __fastcall MenuItem3Click(TObject *Sender);
	void __fastcall Button2Click(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall TerminalCheckClick(TObject *Sender);
	void __fastcall RamReadChkClick(TObject *Sender);
	void __fastcall AutoMpuReadCheckClick(TObject *Sender);
private:	// [U[錾
	TThread *comThread;


	#define SORT_MODE_ADDRESS_UP     0
	#define SORT_MODE_ADDRESS_DOWN   1
	#define SORT_MODE_VAR_NAME_UP    2
	#define SORT_MODE_VAR_NAME_DOWN  3

	#define SORT_MODE_FILE_NAME_NON  0
	#define SORT_MODE_FILE_NAME_UP   1
	#define SORT_MODE_FILE_NAME_DOWN 2

	int sortMode[2];











	struct MEM_RANGE{
		UINT size;
		int width;
		int romTop;
		int romEnd;
		int ramTop;
		int ramEnd;
		int ioTop;
		int ioEnd;
	}memRange[2];

	AnsiString srcFile;
	AnsiString srcFileName[2];

	int readAdrPos;


	int __fastcall  AdrFileRead(AnsiString name, AnsiString name2);
	void __fastcall SrcFileRead(AnsiString name, AnsiString oldName);
	void __fastcall CheckDate(void);
	void __fastcall LoadIniFile(AnsiString name, int mode=0);
	void __fastcall SaveIniFile(AnsiString name, int mode=0);
	void __fastcall GetAdrRange(void);

	void __fastcall SortData(int mode);
	void __fastcall SortData(int *mode);
	void __fastcall MapFileRead(AnsiString name);
	HANDLE __fastcall OpenComPort(AnsiString port, int speed);

	void __fastcall SetReadAreaPermit(void);

	int popupPos;
	int popupPosMark;


	int oscModePos;

public:		// [U[錾
 	__fastcall TMainForm(TComponent* Owner);

	//int memBuf[0x10000+1000];
	UCHAR memBuf[0xffffff+1000];	//[obt@[

	struct READ_RANGE readRange;

	HANDLE handleCom;

	struct MEM_DATA memData[MEM_DATA_MAX_SIZE];
	int memDataSize;

	__int64 __fastcall GetData(int adr, int model, int mark);
	void __fastcall MpuWriteCommand(int size, int adr, UINT data);
	int __fastcall FindVar(AnsiString name, AnsiString file,struct MEM_DATA *mem);

	int autoMpuRead;


};

//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
